const { contextBridge, ipcRenderer } = require("electron");

const checkValid = false;
const validChannels = [];

contextBridge.exposeInMainWorld("ipcRenderer", {
  send: (channel, data) => {
    if (!checkValid || validChannels.includes(channel)) {
      ipcRenderer.send(channel, data);
    }
  },
  on: (channel, callback) => {
    if (!checkValid || validChannels.includes(channel)) {
      // Filtering the event param from ipcRenderer
      const newCallback = (_, data) => callback({}, data);
      ipcRenderer.on(channel, newCallback);
    }
  },
  once: (channel, callback) => {
    if (!checkValid || validChannels.includes(channel)) {
      const newCallback = (_, data) => callback({}, data);
      ipcRenderer.once(channel, newCallback);
    }
  },
  invoke: (channel, ...args) => {
    if (!checkValid || validChannels.includes(channel)) {
      return ipcRenderer.invoke(channel, ...args);
    }
  },
  removeListener: (channel, callback) => {
    if (!checkValid || validChannels.includes(channel)) {
      ipcRenderer.removeListener(channel, callback);
    }
  },
  removeAllListeners: (channel) => {
    if (!checkValid || validChannels.includes(channel)) {
      ipcRenderer.removeAllListeners(channel);
    }
  },
});
